-----------------------------------------------------------------------
-- Locale
--

local MAX_RESULTS = 5

local l = GetLocale()

local TOO_MANY = "Too many results, %d not shown."
local PREFIX = "cg: "
local CG_USAGE = "Whisper me '!%s <anything>' to search."
local NO_DATA = "No results found for %q."
local NO_SKILL = "I don't know this skill. Accepted commands are %s."
local ACCEPTED = "Accepted commands are %s."

-- All tradeskills ninjaed from Babble-Tradeskill-2.2
local skills = nil
if l == "enUS" then
	skills = {
		["Alchemy"] = true,
		["Armorsmith"] = true,
		["Blacksmithing"] = true,
		["Cooking"] = true,
		["Dragonscale Leatherworking"] = true,
		["Elemental Leatherworking"] = true,
		["Enchanting"] = true,
		["Engineering"] = true,
		["First Aid"] = true,
		["Jewelcrafting"] = true,
		["Leatherworking"] = true,
		["Master Axesmith"] = true,
		["Master Hammersmith"] = true,
		["Master Swordsmith"] = true,
		["Tailoring"] = true,
		["Tribal Leatherworking"] = true,
		["Weaponsmith"] = true,
	}
	for k, v in pairs(skills) do
		skills[k] = k
	end
elseif l == "deDE" then
	skills = {
		["Alchemy"] = "Alchimie",
		["Armorsmith"] = "Rstungsschmied",
		["Blacksmithing"] = "Schmiedekunst",
		["Cooking"] = "Kochkunst",
		["Dragonscale Leatherworking"] = "Drachenschuppenlederverarbeitung",
		["Elemental Leatherworking"] = "Elementarlederverarbeitung",
		["Enchanting"] = "Verzauberkunst",
		["Engineering"] = "Ingenieurskunst",
		["First Aid"] = "Erste Hilfe",
		["Jewelcrafting"] = "Juwelenschleifen",
		["Leatherworking"] = "Lederverarbeitung",
		["Master Axesmith"] = "Axtschmied",
		["Master Hammersmith"] = "Hammerschmied",
		["Master Swordsmith"] = "Schwertschmied",
		["Tailoring"] = "Schneiderei",
		["Tribal Leatherworking"] = "Stammeslederverarbeitung",
		["Weaponsmith"] = "Waffenschmied",
	}
elseif l == "frFR" then
	skills = {
		["Alchemy"] = "Alchimie",
		["Armorsmith"] = "Fabricant d'armures",
		["Blacksmithing"] = "Forge",
		["Cooking"] = "Cuisine",
		["Dragonscale Leatherworking"] = "Travail du cuir d'cailles de dragon",
		["Elemental Leatherworking"] = "Travail du cuir lmentaire",
		["Enchanting"] = "Enchantement",
		["Engineering"] = "Ingnierie",
		["First Aid"] = "Premiers soins",
		["Jewelcrafting"] = "Joaillerie",
		["Leatherworking"] = "Travail du cuir",
		["Master Axesmith"] = "Fabricant de haches",
		["Master Hammersmith"] = "Fabricant de marteaux",
		["Master Swordsmith"] = "Fabricant d'pes",
		["Tailoring"] = "Couture",
		["Tribal Leatherworking"] = "Travail du cuir tribal",
		["Weaponsmith"] = "Fabricant d'armes",
	}
elseif l == "zhCN" then
	skills = {
		["Alchemy"] = "炼金术",
		["Armorsmith"] = "护甲锻造师",
		["Blacksmithing"] = "锻造",
		["Cooking"] = "烹饪",
		["Dragonscale Leatherworking"] = "龙鳞制皮",
		["Elemental Leatherworking"] = "元素制皮",
		["Enchanting"] = "附魔",
		["Engineering"] = "工程学",
		["First Aid"] = "急救",
		["Jewelcrafting"] = "珠宝加工",	--TBC check
		["Leatherworking"] = "制皮",
		["Master Axesmith"] = "铸斧大师",
		["Master Hammersmith"] = "铸锤大师",
		["Master Swordsmith"] = "铸剑大师",
		["Tailoring"] = "裁缝",
		["Tribal Leatherworking"] = "部族制皮",
		["Weaponsmith"] = "武器锻造师",
	}
elseif l == "zhTW" then
	skills = {
		["Alchemy"] = "鍊金術",
		["Armorsmith"] = "護甲鍛造師",
		["Blacksmithing"] = "鍛造",
		["Cooking"] = "烹飪",
		["Dragonscale Leatherworking"] = "龍鱗製皮",
		["Elemental Leatherworking"] = "元素製皮",
		["Enchanting"] = "附魔",
		["Engineering"] = "工程學",
		["First Aid"] = "急救",
		["Jewelcrafting"] = "珠寶設計",
		["Leatherworking"] = "製皮",
		["Master Axesmith"] = "鑄斧大師",
		["Master Hammersmith"] = "鑄錘大師",
		["Master Swordsmith"] = "鑄劍大師",
		["Tailoring"] = "裁縫",
		["Tribal Leatherworking"] = "部族製皮",
		["Weaponsmith"] = "武器鑄造",
	}
elseif l == "koKR" then
	skills = {
		["Alchemy"] = "연금술",
		["Armorsmith"] = "방어구제작",
		["Blacksmithing"] = "대장기술",
		["Cooking"] = "요리",
		["Dragonscale Leatherworking"] = "용비늘 가죽세공",
		["Elemental Leatherworking"] = "원소 가죽세공",
		["Enchanting"] = "마법부여",
		["Engineering"] = "기계공학",
		["First Aid"] = "응급치료",
		["Jewelcrafting"] = "보석세공",
		["Leatherworking"] = "가죽세공",
		["Master Axesmith"] = "도끼 제작의 대가",
		["Master Hammersmith"] = "망치 제작의 대가",
		["Master Swordsmith"] = "검 제작의 대가",
		["Tailoring"] = "재봉술",
		["Tribal Leatherworking"] = "전통 가죽세공",
		["Weaponsmith"] = "무기제작",
	}
elseif l == "esES" then
	skills = {
		["Alchemy"] = "Alquimia",
		["Armorsmith"] = "Forjador de armaduras", -- check
		["Blacksmithing"] = "Herreria",
		["Cooking"] = "Cocina",
		["Dragonscale Leatherworking"] = "Peleteria dragontina", -- check
		["Elemental Leatherworking"] = "Peleteria elemental", -- check
		["Enchanting"] = "Encantamiento",
		["Engineering"] = "Ingenieria",
		["First Aid"] = "Primeros auxilios",
		["Jewelcrafting"] = "Joyeria",
		["Leatherworking"] = "Peleteria",
		["Master Axesmith"] = "Forjador de hachas",
		["Master Hammersmith"] = "Forjador de martillos", -- check
		["Master Swordsmith"] = "Forjador de espadas", -- check
		["Tailoring"] = "Sastreria",
		["Tribal Leatherworking"] = "Peleteria tribal", -- check
		["Weaponsmith"] = "Forjador de armas", -- check
	}
end

local bangMappings = {
	alchemy = {
		["Alchemy"] = true,
	},
	blacksmith = {
		["Blacksmithing"] = true,
		["Armorsmith"] = true,
		["Master Axesmith"] = true,
		["Master Hammersmith"] = true,
		["Master Swordsmith"] = true,
		["Weaponsmith"] = true,
	},
	cooking = {
		["Cooking"] = true,
	},
	leather = {
		["Dragonscale Leatherworking"] = true,
		["Elemental Leatherworking"] = true,
		["Tribal Leatherworking"] = true,
		["Leatherworking"] = true,
	},
	enchanting = {
		["Enchanting"] = true,
	},
	engineering = {
		["Engineering"] = true,
	},
	firstaid = {
		["First Aid"] = true,
	},
	jewel = {
		["Jewelcrafting"] = true,
	},
	tailor = {
		["Tailoring"] = true,
	},
}
bangMappings.alc = bangMappings.alchemy
bangMappings.bs = bangMappings.blacksmith
bangMappings.cook = bangMappings.cooking
bangMappings.lw = bangMappings.leather
bangMappings.enchant = bangMappings.enchanting
bangMappings.eng = bangMappings.engineering
bangMappings.aid = bangMappings.firstaid
bangMappings.jc = bangMappings.jewel
bangMappings.gem = bangMappings.jewel
bangMappings.tailoring = bangMappings.tailor
bangMappings.craft = true
bangMappings.cg = true

-----------------------------------------------------------------------
-- Tooltip scanner, mostly stolen from Gratuity.
--

local scanItem
do
	local scanner = CreateFrame("GameTooltip")
	scanner:SetOwner(WorldFrame, "ANCHOR_NONE")
	local lcache, rcache = {}, {}
	for i = 1, 30 do
		lcache[i], rcache[i] = scanner:CreateFontString(), scanner:CreateFontString()
		lcache[i]:SetFontObject(GameFontNormal); rcache[i]:SetFontObject(GameFontNormal)
		scanner:AddFontStrings(lcache[i], rcache[i])
	end
	local function erase()
		for i = 1, scanner:NumLines() do rcache[i]:SetText() end
		scanner:ClearLines()
	end
	local scannerCache = {}
	function scanItem(itemLink)
		erase()
		scanner:SetHyperlink(itemLink)
		for k in pairs(scannerCache) do scannerCache[k] = nil end
		for i = 1, scanner:NumLines() do
			local left, right = lcache[i]:GetText(), rcache[i]:GetText()
			if left then table.insert(scannerCache, left) end
			if right then table.insert(scannerCache, right) end
		end
		return table.concat(scannerCache)
	end
end

-----------------------------------------------------------------------
-- CraftyGnome
--

local db = nil
local cache = {}
local acceptedCommands = {}
local addon = CreateFrame("Frame")

function addon:CRAFT_SHOW()
	local name = GetCraftName()
	if not db[name] then db[name] = {} end
	for i = 1, GetNumCrafts() do
		local skillName, _, skillType = GetCraftInfo(i)
		if skillType ~= "header" and skillName then
			db[name][GetCraftRecipeLink(i)] = true
		end
	end
end

function addon:TRADE_SKILL_SHOW()
	local name = GetTradeSkillLine()
	if not db[name] then db[name] = {} end
	for i = 1, GetNumTradeSkills() do
		local skillName, skillType = GetTradeSkillInfo(i)
		if skillType ~= "header" and skillName then
			db[name][GetTradeSkillRecipeLink(i)] = true
		end
	end
end

local function updateAcceptedCommands()
	for k in pairs(acceptedCommands) do acceptedCommands[k] = nil end
	for k, v in pairs(bangMappings) do
		for skill in pairs(v) do
			if db[skills[skill]] then
				table.insert(acceptedCommands, "!" .. k)
				break
			end
		end
	end
end

do
	local ctl = ChatThrottleLib
	local reply = ctl and
		function(msg, player) ctl:SendChatMessage("BULK", "CraftyGnome", PREFIX .. msg, "WHISPER", nil, player) end or
		function(msg, player) SendChatMessage(PREFIX .. msg, "WHISPER", nil, player) end

	local function updateCache(database)
		for item in pairs(database) do
			if not cache[item] then
				cache[item] = scanItem(item):lower()
			end
		end
	end

	local function processChat(msg, player, isWhisper)
		local cmd = select(3, msg:find("^!(%S+)"))
		if not cmd or not bangMappings[cmd] then return end
		if type(bangMappings[cmd]) == "boolean" then
			updateAcceptedCommands()
			reply(ACCEPTED:format(acceptedCommands), player)
			return
		end
		local query = select(3, msg:find("^!%S+%s(.*)"))
		if query then
			local dbToUse = nil
			for k in pairs(bangMappings[cmd]) do
				if db[skills[k]] then
					dbToUse = db[skills[k]]
					break
				end
			end
			if dbToUse then
				local name = GetItemInfo(query)
				if name then query = name:lower()
				else query = query:lower() end
				updateCache(dbToUse)
				local tbl = nil
				for item, details in pairs(cache) do
					if details:find(query) then
						if not tbl then tbl = {} end
						table.insert(tbl, item)
					end
				end
				if tbl then
					if #tbl > MAX_RESULTS then
						local d = #tbl - MAX_RESULTS
						for i = 1, d do
							table.remove(tbl)
						end
						reply(TOO_MANY:format(d), player)
					end

					table.sort(tbl)
					for i, v in ipairs(tbl) do reply(v, player) end
					tbl = nil
				elseif isWhisper then
					reply(NO_DATA:format(query), player)
				end
			else
				updateAcceptedCommands()
				reply(NO_SKILL:format(table.concat(acceptedCommands, ", ")), player)
			end
		elseif isWhisper then
			reply(CG_USAGE:format(cmd), player)
		end
	end
	function addon:CHAT_MSG_GUILD(msg, player)
		processChat(msg, player)
	end
	function addon:CHAT_MSG_WHISPER(msg, player)
		processChat(msg, player, true)
	end
end

function addon:PLAYER_ENTERING_WORLD()
	if not CraftyGnomeDB then CraftyGnomeDB = {} end
	local realm = GetRealmName()
	if not CraftyGnomeDB[realm] then CraftyGnomeDB[realm] = {} end
	local faction = UnitFactionGroup("player")
	if not CraftyGnomeDB[realm][faction] then CraftyGnomeDB[realm][faction] = {} end
	db = CraftyGnomeDB[realm][faction]

	if not db.version then
		for k in pairs(db) do db[k] = nil end
		db.version = 2
	end

	addon:UnregisterEvent("PLAYER_ENTERING_WORLD")
end

local orig = ChatFrame_MessageEventHandler
local chatPrefixTest = "^" .. PREFIX
ChatFrame_MessageEventHandler = function(event, ...)
	if event == "CHAT_MSG_WHISPER" then
		local cmd = select(3, arg1:find("^!(%S+)%s"))
		if acceptedCommands[cmd] then return end
	elseif event == "CHAT_MSG_WHISPER_INFORM" and arg1:find(chatPrefixTest) then
		return
	end
	return orig(event, ...)
end

addon:SetScript("OnEvent", function(self, event, ...)
	self[event](self, ...)
end)
addon:RegisterEvent("PLAYER_ENTERING_WORLD")
addon:RegisterEvent("CHAT_MSG_GUILD")
addon:RegisterEvent("CHAT_MSG_WHISPER")
addon:RegisterEvent("CRAFT_SHOW")
addon:RegisterEvent("TRADE_SKILL_SHOW")

